//------------------------------------------------------------------
#property copyright "mladen edit by www.expforex.com"
#property link      "www.forex-tsd.com"
//indicators-expert-systems-tools/14880-rsi-indicator-47.html#post626857
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  LimeGreen

extern int RsiPeriod    = 3;
extern int UpDownPeriod = 2;
extern int ROCPeriod    = 100;
extern int Price        = PRICE_CLOSE;

//
//
//
//
//

double rsi[];
double prices[];
double updown[];
double roc[];

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
extern string Alerts="    www.expforex.com";
extern bool AlerT=true;  //              
extern bool Mail=true;   //           
extern bool Push=true;   //    
extern bool Arrow=true;  //    
extern int shift=1;      //      0 -   1 -  
int timeee;              //  
string nameInd;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetArrow(int cd,color cl,
              string nm="",datetime t1=0,double p1=0,int sz=3)
  {
   if(nm=="") nm=DoubleToStr(Time[0],0);
   if(t1<=0) t1=Time[0];
   if(p1<=0) p1=Bid;
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
   //if(wind==-1)
   
   wind=0;
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_ARROW,wind,0,0);
   ObjectSet(nm,OBJPROP_TIME1,t1);
   ObjectSet(nm,OBJPROP_PRICE1,p1);
   ObjectSet(nm,OBJPROP_ARROWCODE,cd);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_WIDTH,sz);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Expforex_AlertArrow(string text="",int arrowdir=0,bool history=false,int i=0)
  {
   nameInd=WindowExpertName();
   int wind=WindowFind(nameInd);
   if(wind==-1)wind=0;
   ObjectCreate("Originalalert",OBJ_LABEL,wind,0,0);
   ObjectSetText("Originalalert"," AlertArrow www.expforex.com",10,"Arial Bold",Red);
   ObjectSet("Originalalert",OBJPROP_CORNER,2);
   ObjectSet("Originalalert",OBJPROP_XDISTANCE,200);
   ObjectSet("Originalalert",OBJPROP_YDISTANCE,10);

   if(!history)
     {
      if(AlerT) Alert(text);
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shift],0),Time[shift],Low[shift]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shift],0),Time[shift],High[shift]);
      if(!IsTesting())if(Mail) SendMail(text,text);
      if(!IsTesting())if(Push) SendNotification(text);
     }
   if(history)
     {
      //  Print(i+"arrowdir="+arrowdir);
      if(Arrow) if(arrowdir==1) SetArrow(241,Blue,nameInd+DoubleToStr(Time[shift+i],0),Time[shift+i],Low[shift+i]);
      if(Arrow) if(arrowdir==2) SetArrow(242,Red,nameInd+DoubleToStr(Time[shift+i],0),Time[shift+i],High[shift+i]);

     }

  }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0,rsi);
   SetIndexBuffer(1,prices);
   SetIndexBuffer(2,updown); SetIndexEmptyValue(2,0);
   SetIndexBuffer(3,roc);
   return(0);
  }
//
//
//
//
//

int start()
  {
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;

//
//
//
//
//

   for(int i=limit; i>=0; i--)
     {
      prices[i]=iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if(prices[i]==prices[i+1]) updown[i]=0;
      if(prices[i] <  prices[i+1]) if(updown[i+1] > 0) updown[i] = -1; else updown[i] = updown[i+1]-1;
      if(prices[i] >  prices[i+1]) if(updown[i+1] < 0) updown[i] =  1; else updown[i] = updown[i+1]+1;
     }
   for(i=limit; i>=0; i--)
     {
      double trsi = iRSI(NULL,0,RsiPeriod,Price,i);
      double ursi = iRSIOnArray(updown,0,UpDownPeriod,i);
      roc[i]=0;
      if(prices[i+1]!=0) roc[i]=(prices[i]/prices[i+1]-1.0)*100.0;

      double ROC_Percent=0;
      for(int k=1; k<=ROCPeriod; k++)
         if(roc[i]>=roc[i+k]) ROC_Percent++;
      ROC_Percent=(ROC_Percent/ROCPeriod)*100;

      //
      //
      //
      //
      //

      rsi[i]=(trsi+ursi+ROC_Percent)/3.0;
     }

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   nameInd=WindowExpertName();
   if(timeee!=Time[0] && rsi[shift+1]>=10 && rsi[shift]<10)
     {

      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP",1);
      timeee=Time[0];
     }

   if(timeee!=Time[0] && rsi[shift+1]<=90 && rsi[shift]>90)
     {
      Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN",2);
      timeee=Time[0];
     }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+

//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+
   if(counted_bars>0) counted_bars--;
   int limit2=Bars-counted_bars;
   for(int i2=0; i2<limit2; i2++)
     {
      nameInd=WindowExpertName();
      if(rsi[shift+1+i2]>=10 && rsi[shift+i2]<10)
        {
         Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" UP"+i2,1,true,i2);
        }

      if(rsi[shift+1+i2]<=90 && rsi[shift+i2]>90)
        {
         Expforex_AlertArrow(Symbol()+" "+Period()+nameInd+" DN"+i2,2,true,i2);
        }
     }
//+======================================================================================+
//+================================ www.expforex.com edit AlertArrow ====================+
//+======================================================================================+


   return(0);
  }
//+------------------------------------------------------------------+
